## ros-kinetic-rviz-visual-tools 3.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(rviz_visual_tools)

add_definitions(-std=c++11)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Warnings
add_definitions(-W -Wall -Wextra
  #-Wcast-qual
  -Wwrite-strings -Wunreachable-code -Wpointer-arith
  -Winit-self -Wredundant-decls
  -Wno-unused-parameter -Wno-unused-function)

find_package(catkin REQUIRED COMPONENTS
  eigen_conversions
  geometry_msgs
  graph_msgs
  roscpp
  rostest
  std_msgs
  tf_conversions
  trajectory_msgs
  visualization_msgs
  roslint
  eigen_stl_containers
  rviz
  sensor_msgs
)

find_package(Eigen3 REQUIRED)
find_package(Boost REQUIRED thread system)

# Qt 4 or 5
if(rviz_QT_VERSION VERSION_LESS "5")
  find_package(Qt4 ${rviz_QT_VERSION} REQUIRED QtCore QtGui)
  include(${QT_USE_FILE})
  macro(qt_wrap_ui)
    qt4_wrap_ui(${ARGN})
  endmacro()
  macro(qt_wrap_cpp)
    qt4_wrap_cpp(${ARGN})
  endmacro()
else()
  find_package(Qt5 ${rviz_QT_VERSION} REQUIRED Core Widgets)
  set(QT_LIBRARIES Qt5::Widgets)
  macro(qt_wrap_ui)
    qt5_wrap_ui(${ARGN})
  endmacro()
  macro(qt_wrap_cpp)
    qt5_wrap_cpp(${ARGN})
  endmacro()
endif()
## Prefer the Qt signals and slots to avoid defining "emit", "slots",
## etc because they can conflict with boost signals, so define QT_NO_KEYWORDS here.
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
add_definitions(-DQT_NO_KEYWORDS)

catkin_package(
  LIBRARIES
    ${PROJECT_NAME}
    ${PROJECT_NAME}_gui
    ${PROJECT_NAME}_remote_control
    ${PROJECT_NAME}_imarker_simple
  CATKIN_DEPENDS
    eigen_conversions
    geometry_msgs
    visualization_msgs
    graph_msgs
    std_msgs
    tf_conversions
    trajectory_msgs
    sensor_msgs
    roscpp
  INCLUDE_DIRS
    include
)

include_directories(SYSTEM include ${catkin_INCLUDE_DIRS} ${EIGEN3_INCLUDE_DIRS})

###########
## Build ##
###########

## specify which header files need to be run through "moc",
## Qt's meta-object compiler.
qt_wrap_cpp(MOC_FILES
  src/${PROJECT_NAME}_gui.h
  src/key_tool.h
)

## specify the list of source files, including the output of
## the previous command which is stored in ``${MOC_FILES}``.
set(SOURCE_FILES
  src/${PROJECT_NAME}_gui.cpp
  src/key_tool.cpp
)

# Rviz GUI library
add_library(${PROJECT_NAME}_gui ${SOURCE_FILES} src/remote_control.cpp)
target_link_libraries(${PROJECT_NAME}_gui ${rviz_DEFAULT_PLUGIN_LIBRARIES} ${QT_LIBRARIES} ${catkin_LIBRARIES})

# Remote control library
add_library(${PROJECT_NAME}_remote_control src/remote_control.cpp)
target_link_libraries(${PROJECT_NAME}_remote_control ${catkin_LIBRARIES})

# Visualization Tools Library
add_library(${PROJECT_NAME}
  src/${PROJECT_NAME}.cpp
  src/tf_visual_tools.cpp
)
target_link_libraries(${PROJECT_NAME}
  ${PROJECT_NAME}_remote_control
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

# Library
add_library(${PROJECT_NAME}_imarker_simple
  src/imarker_simple.cpp
)
target_link_libraries(${PROJECT_NAME}_imarker_simple
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  ${PROJECT_NAME}
)

# Demo executable
add_executable(${PROJECT_NAME}_demo src/${PROJECT_NAME}_demo.cpp)
target_link_libraries(${PROJECT_NAME}_demo
  ${catkin_LIBRARIES} ${PROJECT_NAME}
  )

# Demo executable
add_executable(imarker_simple_demo src/imarker_simple_demo.cpp)
target_link_libraries(imarker_simple_demo
  ${catkin_LIBRARIES} ${PROJECT_NAME} ${PROJECT_NAME}_imarker_simple
)

##########
## TEST ##
##########

if(CATKIN_ENABLE_TESTING)

  add_rostest_gtest(rvt_test launch/rvt_test.launch tests/rvt_test.cpp)
  target_link_libraries(rvt_test
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${Boost_LIBRARIES}
  )

endif()

## Test for correct C++ source code
roslint_cpp()

#############
## Install ##
#############

# Install libraries
install(
  TARGETS
    ${PROJECT_NAME}
    ${PROJECT_NAME}_gui
    ${PROJECT_NAME}_remote_control
    ${PROJECT_NAME}_imarker_simple
  LIBRARY DESTINATION
    ${CATKIN_PACKAGE_LIB_DESTINATION}
)

# Install header files
install(DIRECTORY include/${PROJECT_NAME}/   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

# Install shared resources
install(DIRECTORY launch    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})
install(DIRECTORY resources DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

# Install xml plugin config
install(FILES
  plugin_description.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

# Install executables
install(TARGETS ${PROJECT_NAME}_demo imarker_simple_demo
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== debian/changelog ===
ros-kinetic-rviz-visual-tools (3.6.0-0xenial) xenial; urgency=high

  * Addresses Issue #49 - Default Constructor Not Nodelet Friendly
  * Added option to pass in a node handle in the constructor that defaults to
  * Reset marker should publish initialized quaternion
  * Improve code quality - add const, static, C++11 features, clang-format
  * Create demo executable for IMarkerSimple
  * Improve memory efficiency of functions
  * Contributors: Dave Coleman, Geoffrey Chiou, Victor Lamoine

 -- Dave Coleman <davetcoleman@gmail.com>  Mon, 15 Jan 2018 07:00:00 -0000

ros-kinetic-rviz-visual-tools (3.5.1-0xenial) xenial; urgency=high

  * Normalize quaternion before storage
  * Fix for ambiguous function call to publishAxis
  * Add linking to visualization tools library for imarker_simple
  * Added arrow pub to take two points
  * Document clang-tidy
  * catkin lint
  * roslint applied
  * Clang-format again
  * Clang-tidy ALL
  * C++11 optimizations
  * Fix deprecated calls to convertFromXYZRPY
  * Add new convertPoseSafe() function
  * New convertFromXYZRPY() function to avoid deprecation warning
  * Allow to enable frame locking in the markers/markers arrays
  * Update license year
  * IMarkerSimple: set name and pose
  * New printTransformFull() function
  * Removed deprecated warning
  * New class for easily using 6dof imarkers
  * More options to tf_visual_tools
  * Update README.md
  * Contributors: Andy McEvoy, Dave Coleman, Fadri Furrer, Victor Lamoine

 -- Dave Coleman <davetcoleman@gmail.com>  Mon, 25 Dec 2017 07:00:00 -0000

ros-kinetic-rviz-visual-tools (3.4.1-0xenial) xenial; urgency=high

  * Add dependency on QT5 for Ubuntu Zesty/Lunar support
  * Allow publishPath with std_msgs::ColorRGBA
  * Make INFO msg DEBUG
  * Contributors: Dave Coleman, Victor Lamoine

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 20 Jun 2017 06:00:00 -0000

ros-kinetic-rviz-visual-tools (3.4.0-0xenial) xenial; urgency=high

  * Consolidated publishing into RemoteReciever class
  * Improve console output
  * Add RvizGui and KeyTool
  * Enable remote control from withing rviz_visual_tools
  * New publishPath() function
  * Shorten number of lines printTranslation() requires
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Wed, 02 Nov 2016 06:00:00 -0000

ros-kinetic-rviz-visual-tools (3.3.0-0xenial) xenial; urgency=high

  * BREAKING CHANGE: Make batch publishing enabled by default
  * Removed enableInternalBatchPublishing()
  * Removed triggerInternalBatchPublishAndDisable()
  * Deprecated triggerBatchPublish() in favor of function name trigger()
  * Deprecated triggerBatchPublishAndDisable()
  * Ability to trigger every x markers that are in queue, ideal in for loops
  * New waitForMarkerPub() function that takes timeout
  * Add std::move
  * Added Docker for Kinetic
  * Added delay to demo to allow rviz to load in Docker
  * Change the sphere marker type from SPHERE_LIST to SPHERE - This makes irregularly scaled spheres (i.e. ellipsoids) to be rendered correctly.
  * Contributors: Dave Coleman, Miguel Prada

 -- Dave Coleman <davetcoleman@gmail.com>  Wed, 28 Sep 2016 06:00:00 -0000

ros-kinetic-rviz-visual-tools (3.2.0-0xenial) xenial; urgency=high

  * Catkin depend on eigen and tf conversions
  * New warning
  * Added EulerConvention enum
  * Added new convertFromXYZRPY() function
  * Added new tests
  * Contributors: Dave Coleman, Enrique Fernandez

 -- Dave Coleman <davetcoleman@gmail.com>  Thu, 14 Jul 2016 06:00:00 -0000

ros-kinetic-rviz-visual-tools (3.1.0-0xenial) xenial; urgency=high

  * Switched publishPath() to use cylinders
  * Added new publishLineStrip() function
  * Added new publishPath() functions
  * Added new publishAxis() functions
  * Update screenshot
  * Broke publishPath() API for recent addition - incorrect Eigen vector used
  * New publishPath() function for Affine3d
  * New publishAxis() functions that use scale
  * New publishAxisInternal() function for more efficient publishing
  * New publishAxisPath() function for showing a series of coordinate axis
  * Added warning for batch publishing when not enabled
  * Bug fix in publishLines() for id incrementing
  * New scaleToString() function
  * Bug fix for scaling in coordinate axis
  * Improved demo to have multiple scales visualized
  * Revert "Remove graph msgs"
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Wed, 06 Jul 2016 06:00:00 -0000

ros-kinetic-rviz-visual-tools (3.0.0-0xenial) xenial; urgency=high

  * Improve Travis script
  * Upgrade to Eigen3 per ROS Kinetic requirements
  * New screenshot
  * Refactored entire scaling method - all sizes of shapes have been affected
  * Renamed scales
  * Removed const reference for primitive types in function headers
  * Cleaned up getScale() function
  * New publishSpheres function
  * Two new tests & screenshot
  * Deprecated size REGULAR
  * Number scale sizes
  * New intToRvizScale() function
  * New publishSpheres() functions for showing list of lines AND colors
  * New publishLines() functions for using LINE_LIST
  * New publishCylinder() function that uses scales
  * Bug fix for getVectorBetweenPoints() when vector is all zeros
  * New printTranslation() function
  * added intToRvizColor() for interfaces that do not directly depend on Rviz Visual Tools, such as OMPL
  * publishPath with vector of colors
  * Update demo
  * New variant of publishPath with vector of colors
  * New publishSphere() helper
  * Add eigen_stl_containers
  * Add missing breaks in switch statement
  * Add namespace to ease debugging ROS messages
  * Do not pass Eigen structures by value
  * Fix all vector<Eigen> to EigenSTL::vector_Vector3d as recommended by @VictorLamoine
  * Hide upstream package cast warning
  * Overload new operator for Eigen structures
  * Changing the angles will change the opening angle of the cone
  * Better way to turn on C++11, maybe?
  * Removed deprecated code for Kinetic
  * Began converting to C++11


=== debian/control ===
Source: ros-kinetic-rviz-visual-tools
Section: misc
Priority: extra
Maintainer: Dave Coleman <davetcoleman@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libqt5x11extras5-dev, ros-kinetic-catkin, ros-kinetic-eigen-conversions, ros-kinetic-eigen-stl-containers, ros-kinetic-geometry-msgs, ros-kinetic-graph-msgs, ros-kinetic-roscpp, ros-kinetic-roslint, ros-kinetic-rostest, ros-kinetic-rosunit, ros-kinetic-rviz, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf-conversions, ros-kinetic-trajectory-msgs, ros-kinetic-visualization-msgs
Homepage: https://github.com/davetcoleman/rviz_visual_tools
Standards-Version: 3.9.2

Package: ros-kinetic-rviz-visual-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5x11extras5-dev, ros-kinetic-eigen-conversions, ros-kinetic-eigen-stl-containers, ros-kinetic-geometry-msgs, ros-kinetic-graph-msgs, ros-kinetic-roscpp, ros-kinetic-roslint, ros-kinetic-rviz, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf-conversions, ros-kinetic-trajectory-msgs, ros-kinetic-visualization-msgs
Description: Utility functions for displaying and debugging data in Rviz via published markers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-rviz-visual-tools//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
